% ===  carrier_wave.m ===
%   4-      
f0 = [400 800 1200 2400];          %  
df = [100 100 100 400];            %  
G = [0 -4 -18 -24];                          % . ., 
Fs = 22050;                                      %  
Wc = 2*f0/Fs;                          % . .  
Wb = 2*df/Fs;                          % .  

% 
T = 2;                             %    
N = T*Fs;                          %    
t = 0:1/Fs:1/Fs*(N-1);                 %   
%    
x = randn(N,1);
%   -
% x = zeros(N,1);
% x(1) = 1;

%  
V0 = 10.^(G/20);                       %    
y = zeros(length(x),1);                %  
yn = zeros(length(x),1);               %  n- 
for n = 1:4
    yn = apbandpass(x, Wc(n), Wb(n));
    y = y + V0(n)*yn;
end

%    
y = y/max(abs(y))*0.99;

figure; plot(t',y);                   %   
xlabel(', '); ylabel(''); 
title('');

%  
[H,f] = freqz(y,1,1000,Fs);
figure; plot(f,20*log10(abs(H)));
xlabel(', '); ylabel(', '); 
title(''); grid on;

