% ===  equalizer_2.m ===
%      
f0 = [125 250 500 1000 2000 4000 8000];          %  
df = [90 180 355 710 1400 2800 5600];            %  
G = [9 6 3 0 -3 -6 -9];                          % . ., 
%G = [0 0 0 0 0 0 0];                          % . ., 
Fs = 22050;                                      %  
Wc = 2*f0/Fs;                          % . .  
Wb = 2*df/Fs;                          % .  

%     
N = 22050;                             %  
t = 0:1/Fs:1/Fs*(N-1);                 %   
x = zeros(N,1);
x(1) = 1;

%  
V0 = 10.^(G/20);                       %    
y = zeros(length(x),1);                %  
yn = zeros(length(x),1);               %  n- 
for n = 1:7
    yn = apbandpass(x, Wc(n), Wb(n));
    y = y + V0(n)*yn;
end

figure; plot(t',y);                   %   
xlabel(', '); ylabel(''); 
title('');

%  
[H,f] = freqz(y,1,1000,Fs);
figure; plot(f,20*log10(abs(H)));
xlabel(', '); ylabel(', '); 
title('');

%  
[P,f] = phasez(y,1,1000,Fs);
P = unwrap(P);
figure; plot(f,P/pi*180);
xlabel(', '); ylabel(', '); 
title('');

%  
%          dP(f)       dP(i*df)
% tau = - -------- = - ---------- ; (di = 1; df = Fs/2/1000; P - )
%          2*pi*df     2*pi*df*di
df = f(2)-f(1);
tau = -diff(P)/(2*pi*df);
figure; plot(f(1:end-1),tau);
xlabel(', '); ylabel(' , '); 
title(' ');